/*

-----------------------------------------------
GTASC - GTA adaptation for TI Calculators
-----------------------------------------------

Programmed by : Olivier SANGALA
Version : 1.2
License : Free under GNU General Public License ( see "gpl.txt" )
Release Date : 05/01/2007
Platform : TI89/TI92+/V200
Website : http://olivier.sangala.free.fr
Email : olivier_sangala@hotmail.com

----------
License
----------

    Copyright (C) 2002-2007 Olivier SANGALA

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    
*/
//-----------------------------------------------------------------------------

// From 'TICT Game Construction Kit' by Thomas Nussbaumer

//--------------------------------------------------------------------------
// KBLIB FUNCTIONS
//--------------------------------------------------------------------------


#define KEYFLAGS_RIGHT   0x0001
#define KEYFLAGS_UP      0x0002
#define KEYFLAGS_DOWN    0x0004
#define KEYFLAGS_LEFT    0x0008

#define KEYFLAGS_2ND     0x0010
#define KEYFLAGS_DIAMOND 0x0020
#define KEYFLAGS_SHIFT   0x0040
#define KEYFLAGS_ALPHA   0x0080 // = HAND (TI92PLUS) 

#define KEYFLAGS_ENTER   0x0200
#define KEYFLAGS_ESC     0x0100

#define KEYFLAGS_PLUS    0x0400
#define KEYFLAGS_MINUS   0x0800

//-----------------------------------------------------------------------------

// calculator type
enum {KF_TI89,KF_TI92PLUS,KF_V200};

//-----------------------------------------------------------------------------


void WaitForAllKeysReleased(void);

void KB_Enable(void);
void KB_Disable(void);

short GetKeyboardState(void);

void WaitForKeyDOWN(short Key);
void WaitForKeyUP(short Key);

//-----------------------------------------------------------------------------
